#include <WiFi.h>

const char* ssid = "ap name";
const char* password =  "pass";

int port = 10024;  //Port number
WiFiServer server(port);
int pin_led = 23;
//int pin_led = 12;
void setup() {
  pinMode(pin_led, OUTPUT);
  WiFi.mode(WIFI_STA); WiFi.begin(ssid, password); //Connect to wifi
  Serial.begin(115200);
  Serial2.begin(115200);
  delay(2500);
  uint8_t cont = 0;
  while (WiFi.status() != WL_CONNECTED) {
    Serial.print(".");
    digitalWrite(pin_led, HIGH); delay(100);
    digitalWrite(pin_led, LOW); delay(300);
    if (cont++ == 5)
      WiFi.reconnect();
  }
  digitalWrite(pin_led, HIGH);   // turn the LED on (HIGH is the voltage level)
  server.begin();
  Serial.println('\n'); Serial.print(WiFi.localIP()); Serial.print(":"); Serial.println(port);
}

int ledState = LOW;
unsigned long previousMillis = 0;
const long interval = 35;
uint8_t cont_led = 0;



uint8_t sum = 0, cont = 5;
const char* resp = "XC01=";


void LedTG(void) {
  if (cont_led != 0) {
    unsigned long currentMillis = millis();
    if (currentMillis - previousMillis >= interval) {
      previousMillis = currentMillis;
      if (ledState == LOW)
        ledState = HIGH;
      else
        ledState = LOW;
      digitalWrite(pin_led, ledState);
      cont_led--;
    }
  } else {
    sum = 0;
    ledState = HIGH;
    digitalWrite(pin_led, ledState);
  }
}

void loop() {
  WiFiClient client = server.available();
  if (client) {
    if (client.connected())Serial.println("Client Connected");
    while (client.connected()) {
      while (client.available() > 0) {
        Serial2.write(client.read());       //Read data from the connected client
        cont_led = 6;
      }
      while (Serial2.available() > 0) {
        char c = Serial2.read();
        if (cont == sum) {
          client.write(c);     //Send Data to connected client
          cont_led = 6;
        } else {
          sum = (c == resp[sum]) ? sum + 1 : 0;
          if (sum == 0)
            sum = (c == resp[sum]) ? sum + 1 : 0;
        }
      }
      LedTG();
    }
    client.stop(); Serial.println("Client Disconnected");
  }
}
